
/*
 *  13 Jun 91  wsak (wk0x@andrew) added mips support
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <sys/types.h>
#include <stdio.h>
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include "asn1.h"
#include "snmp_impl.h"
#include "kernel.h"

#ifndef NULL
#define NULL 0
#endif


static int kmem;
#ifdef DMEM_LOC
int swap;
#endif
int mem;

void
init_kmem(file)
    char *file;
{
    kmem = open(file, O_RDONLY);
    if (kmem < 0){
      fprintf(stderr, "cannot open ");
      perror(file);
      exit(1);
    }
    fcntl(kmem,F_SETFD,1);

    mem = open("/dev/mem",O_RDONLY);    
    if (mem < 0){
      fprintf(stderr, "cannot open ");
      perror("/dev/mem");
      exit(1);
    }
    fcntl(mem,F_SETFD,1);

#ifdef DMEM_LOC
    swap = open(DMEM_LOC,O_RDONLY);
    if (swap < 0){
      fprintf(stderr, "cannot open ");
      perror(DMEM_LOC);
      exit(1);
    }
    fcntl(swap,F_SETFD,1);
#endif
}


/*
 *  Seek into the kernel for a value.
 */
off_t
klseek(base)
     off_t base;
{
  return (lseek(kmem, (off_t)base, SEEK_SET));
}


/*
 *  Read from the kernel 
 */
int
klread(buf, buflen)
    char *buf;
    int buflen;
{
  return (read(kmem, buf, buflen));
}



/*
 *  klookup:
 *
 *  It seeks to the location  off  in kmem
 *  It does a read into  target  of  siz  bytes.
 *
 *  Return NULL on failure and 1 on sucess.
 *
 */



int
klookup(off, target, siz) 
     int     off;
     char   *target;
     int     siz;
{
  off_t retsiz;

  if (!off) return 0; /* return silently */
  
  retsiz = klseek((off_t) off);
  if (retsiz != off) {
    ERROR("klseek\n");
#ifdef EXIT_ON_BAD_KLREAD
    exit(-1);
#endif
    return(NULL);
  }
  if (siz != klread(target, siz)) {
    ERROR("klread\n");
#ifdef EXIT_ON_BAD_KLREAD
    exit(-1);
#endif
    return(NULL);
  }
  return (1);
}
