scan [info tclversion] "%d.%d" a b
if {$a != 7} {
 error "wrong version of Tcl loaded ([info tclversion]): need 7.x"
}
scan $tk_version "%d.%d" a b
if {($a != 4) || ($b < 0)} {
 error "wrong version of Tk loaded ($tk_version): need 4.x"
}
unset a b
set tk_strictMotif 0
proc tkScreenChanged screen {
 set disp [file rootname $screen]
 uplevel #0 upvar #0 tkPriv.$disp tkPriv
 global tkPriv
 if [info exists tkPriv] {
  set tkPriv(screen) $screen
  return
 }
 set tkPriv(afterId) {}
 set tkPriv(buttons) 0
 set tkPriv(buttonWindow) {}
 set tkPriv(dragging) 0
 set tkPriv(focus) {}
 set tkPriv(grab) {}
 set tkPriv(initPos) {}
 set tkPriv(inMenubutton) {}
 set tkPriv(listboxPrev) {}
 set tkPriv(mouseMoved) 0
 set tkPriv(oldGrab) {}
 set tkPriv(popup) {}
 set tkPriv(postedMb) {}
 set tkPriv(pressX) 0
 set tkPriv(pressY) 0
 set tkPriv(screen) $screen
 set tkPriv(selectMode) char
 set tkPriv(window) {}
}
tkScreenChanged [winfo screen .]
bind all <Tab> {focus [tk_focusNext %W]}
bind all <Shift-Tab> {focus [tk_focusPrev %W]}
proc tkCancelRepeat {} {
 global tkPriv
 after cancel $tkPriv(afterId)
 set tkPriv(afterId) {}
}
bind Button <FocusIn> {}
bind Button <Enter> {
 tkButtonEnter %W
}
bind Button <Leave> {
 tkButtonLeave %W
}
bind Button <1> {
 tkButtonDown %W
}
bind Button <ButtonRelease-1> {
 tkButtonUp %W
}
bind Button <space> {
 tkButtonInvoke %W
}
bind Button <Return> {
 if !$tk_strictMotif {
  tkButtonInvoke %W
 }
}
bind Checkbutton <FocusIn> {}
bind Checkbutton <Enter> {
 tkButtonEnter %W
}
bind Checkbutton <Leave> {
 tkButtonLeave %W
}
bind Checkbutton <1> {
 tkCheckRadioInvoke %W
}
bind Checkbutton <space> {
 tkCheckRadioInvoke %W
}
bind Checkbutton <Return> {
 if !$tk_strictMotif {
  tkCheckRadioInvoke %W
 }
}
bind Radiobutton <FocusIn> {}
bind Radiobutton <Enter> {
 tkButtonEnter %W
}
bind Radiobutton <Leave> {
 tkButtonLeave %W
}
bind Radiobutton <1> {
 tkCheckRadioInvoke %W
}
bind Radiobutton <space> {
 tkCheckRadioInvoke %W
}
bind Radiobutton <Return> {
 if !$tk_strictMotif {
  tkCheckRadioInvoke %W
 }
}
proc tkButtonEnter {w} {
 global tkPriv
 if {[$w cget -state] != "disabled"} {
  $w config -state active
  if {$tkPriv(buttonWindow) == $w} {
   $w configure -state active -relief sunken
  }
 }
 set tkPriv(window) $w
}
proc tkButtonLeave w {
 global tkPriv
 if {[$w cget -state] != "disabled"} {
  $w config -state normal
 }
 if {$w == $tkPriv(buttonWindow)} {
  $w configure -relief $tkPriv(relief)
 }
 set tkPriv(window) ""
}
proc tkButtonDown w {
 global tkPriv
 set tkPriv(relief) [lindex [$w config -relief] 4]
 if {[$w cget -state] != "disabled"} {
  set tkPriv(buttonWindow) $w
  $w config -relief sunken
 }
}
proc tkButtonUp w {
 global tkPriv
 if {$w == $tkPriv(buttonWindow)} {
  set tkPriv(buttonWindow) ""
  $w config -relief $tkPriv(relief)
  if {($w == $tkPriv(window))
   && ([$w cget -state] != "disabled")} {
   uplevel #0 [list $w invoke]
  }
 }
}
proc tkButtonInvoke w {
 if {[$w cget -state] != "disabled"} {
  set oldRelief [$w cget -relief]
  set oldState [$w cget -state]
  $w configure -state active -relief sunken
  update idletasks
  after 100
  $w configure -state $oldState -relief $oldRelief
  uplevel #0 [list $w invoke]
 }
}
proc tkCheckRadioInvoke w {
 if {[$w cget -state] != "disabled"} {
  uplevel #0 [list $w invoke]
 }
}
proc tk_dialog {w title text bitmap default args} {
 global tkPriv
 catch {destroy $w}
 toplevel $w -class Dialog
 wm title $w $title
 wm iconname $w Dialog
 wm protocol $w WM_DELETE_WINDOW { }
 wm transient $w [winfo toplevel [winfo parent $w]]
 frame $w.top -relief raised -bd 1
 pack $w.top -side top -fill both
 frame $w.bot -relief raised -bd 1
 pack $w.bot -side bottom -fill both
 label $w.msg -wraplength 3i -justify left -text $text \
 -font -Adobe-Times-Medium-R-Normal--*-180-*-*-*-*-*-*
 pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 3m -pady 3m
 if {$bitmap != ""} {
  label $w.bitmap -bitmap $bitmap
  pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m
 }
 set i 0
 foreach but $args {
  button $w.button$i -text $but -command "set tkPriv(button) $i"
  if {$i == $default} {
   frame $w.default -relief sunken -bd 1
   raise $w.button$i $w.default
   pack $w.default -in $w.bot -side left -expand 1 -padx 3m -pady 2m
   pack $w.button$i -in $w.default -padx 2m -pady 2m
   bind $w <Return> "$w.button$i flash; set tkPriv(button) $i"
  } else {
   pack $w.button$i -in $w.bot -side left -expand 1 \
   -padx 3m -pady 2m
  }
  incr i
 }
 wm withdraw $w
 update idletasks
 set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
 - [winfo vrootx [winfo parent $w]]]
 set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
 - [winfo vrooty [winfo parent $w]]]
 wm geom $w +$x+$y
 wm deiconify $w
 set oldFocus [focus]
 set oldGrab [grab current $w]
 if {$oldGrab != ""} {
  set grabStatus [grab status $oldGrab]
 }
 grab $w
 tkwait visibility $w
 if {$default >= 0} {
  focus $w.button$default
 } else {
  focus $w
 }
 tkwait variable tkPriv(button)
 catch {focus $oldFocus}
 destroy $w
 if {$oldGrab != ""} {
  if {$grabStatus == "global"} {
   grab -global $oldGrab
  } else {
   grab $oldGrab
  }
 }
 return $tkPriv(button)
}
proc tkEntryClipboardKeysyms {copy cut paste} {
 bind Entry <$copy> {
  if {[selection own -displayof %W] == "%W"} {
   clipboard clear -displayof %W
   catch {
    clipboard append -displayof %W [selection get -displayof %W]
   }
  }
 }
 bind Entry <$cut> {
  if {[selection own -displayof %W] == "%W"} {
   clipboard clear -displayof %W
   catch {
    clipboard append -displayof %W [selection get -displayof %W]
    %W delete sel.first sel.last
   }
  }
 }
 bind Entry <$paste> {
  catch {
   %W insert insert [selection get -displayof %W \
   -selection CLIPBOARD]
  }
 }
}
bind Entry <1> {
 tkEntryButton1 %W %x
 %W selection clear
}
bind Entry <B1-Motion> {
 set tkPriv(x) %x
 tkEntryMouseSelect %W %x
}
bind Entry <Double-1> {
 set tkPriv(selectMode) word
 tkEntryMouseSelect %W %x
 catch {%W icursor sel.first}
}
bind Entry <Triple-1> {
 set tkPriv(selectMode) line
 tkEntryMouseSelect %W %x
 %W icursor 0
}
bind Entry <Shift-1> {
 set tkPriv(selectMode) char
 %W selection adjust @%x
}
bind Entry <Double-Shift-1>	{
 set tkPriv(selectMode) word
 tkEntryMouseSelect %W %x
}
bind Entry <Triple-Shift-1>	{
 set tkPriv(selectMode) line
 tkEntryMouseSelect %W %x
}
bind Entry <B1-Leave> {
 set tkPriv(x) %x
 tkEntryAutoScan %W
}
bind Entry <B1-Enter> {
 tkCancelRepeat
}
bind Entry <ButtonRelease-1> {
 tkCancelRepeat
}
bind Entry <Control-1> {
 %W icursor @%x
}
bind Entry <Left> {
 tkEntrySetCursor %W [expr [%W index insert] - 1]
}
bind Entry <Right> {
 tkEntrySetCursor %W [expr [%W index insert] + 1]
}
bind Entry <Shift-Left> {
 tkEntryKeySelect %W [expr [%W index insert] - 1]
 tkEntrySeeInsert %W
}
bind Entry <Shift-Right> {
 tkEntryKeySelect %W [expr [%W index insert] + 1]
 tkEntrySeeInsert %W
}
bind Entry <Control-Left> {
 tkEntrySetCursor %W \
 [string wordstart [%W get] [expr [%W index insert] - 1]]
}
bind Entry <Control-Right> {
 tkEntrySetCursor %W [string wordend [%W get] [%W index insert]]
}
bind Entry <Shift-Control-Left> {
 tkEntryKeySelect %W \
 [string wordstart [%W get] [expr [%W index insert] - 1]]
 tkEntrySeeInsert %W
}
bind Entry <Shift-Control-Right> {
 tkEntryKeySelect %W [string wordend [%W get] [%W index insert]]
 tkEntrySeeInsert %W
}
bind Entry <Home> {
 tkEntrySetCursor %W 0
}
bind Entry <Shift-Home> {
 tkEntryKeySelect %W 0
 tkEntrySeeInsert %W
}
bind Entry <End> {
 tkEntrySetCursor %W end
}
bind Entry <Shift-End> {
 tkEntryKeySelect %W end
 tkEntrySeeInsert %W
}
bind Entry <Delete> {
 if [%W selection present] {
  %W delete sel.first sel.last
 } else {
  %W delete insert
 }
}
bind Entry <BackSpace> {
 tkEntryBackspace %W
}
bind Entry <Control-space> {
 %W selection from insert
}
bind Entry <Select> {
 %W selection from insert
}
bind Entry <Control-Shift-space> {
 %W selection adjust insert
}
bind Entry <Shift-Select> {
 %W selection adjust insert
}
bind Entry <Control-slash> {
 %W selection range 0 end
}
bind Entry <Control-backslash> {
 %W selection clear
}
tkEntryClipboardKeysyms F16 F20 F18
bind Entry <KeyPress> {
 tkEntryInsert %W %A
}
bind Entry <Alt-KeyPress> {# nothing}
bind Entry <Meta-KeyPress> {# nothing}
bind Entry <Control-KeyPress> {# nothing}
bind Entry <Escape> {# nothing}
bind Entry <Return> {# nothing}
bind Entry <KP_Enter> {# nothing}
bind Entry <Tab> {# nothing}
bind Entry <Insert> {
 catch {tkEntryInsert %W [selection get -displayof %W]}
}
if !$tk_strictMotif {
 bind Entry <Control-a> {
  tkEntrySetCursor %W 0
 }
 bind Entry <Control-b> {
  tkEntrySetCursor %W [expr [%W index insert] - 1]
 }
 bind Entry <Control-d> {
  %W delete insert
 }
 bind Entry <Control-e> {
  tkEntrySetCursor %W end
 }
 bind Entry <Control-f> {
  tkEntrySetCursor %W [expr [%W index insert] + 1]
 }
 bind Entry <Control-h> {
  tkEntryBackspace %W
 }
 bind Entry <Control-k> {
  %W delete insert end
 }
 bind Entry <Control-t> {
  tkEntryTranspose %W
 }
 bind Entry <Meta-b> {
  tkEntrySetCursor %W \
  [string wordstart [%W get] [expr [%W index insert] - 1]]
 }
 bind Entry <Meta-d> {
  %W delete insert [string wordend [%W get] [%W index insert]]
 }
 bind Entry <Meta-f> {
  tkEntrySetCursor %W [string wordend [%W get] [%W index insert]]
 }
 bind Entry <Meta-BackSpace> {
  %W delete [string wordstart [%W get] [expr [%W index insert] - 1]] \
  insert
 }
 tkEntryClipboardKeysyms Meta-w Control-w Control-y
 bind Entry <2> {
  %W scan mark %x
  set tkPriv(x) %x
  set tkPriv(y) %y
  set tkPriv(mouseMoved) 0
 }
 bind Entry <B2-Motion> {
  if {abs(%x-$tkPriv(x)) > 2} {
   set tkPriv(mouseMoved) 1
  }
  %W scan dragto %x
 }
 bind Entry <ButtonRelease-2> {
  if !$tkPriv(mouseMoved) {
   catch {
    %W insert @%x [selection get -displayof %W]
   }
  }
 }
}
proc tkEntryButton1 {w x} {
 global tkPriv
 set tkPriv(selectMode) char
 set tkPriv(mouseMoved) 0
 set tkPriv(pressX) $x
 $w icursor @$x
 $w selection from @$x
 if {[lindex [$w configure -state] 4] == "normal"} {focus $w}
}
proc tkEntryMouseSelect {w x} {
 global tkPriv
 set cur [$w index @$x]
 set anchor [$w index anchor]
 if {($cur != $anchor) || (abs($tkPriv(pressX) - $x) >= 3)} {
  set tkPriv(mouseMoved) 1
 }
 switch $tkPriv(selectMode) {
  char {
   if $tkPriv(mouseMoved) {
    if {$cur < [$w index anchor]} {
     $w selection to $cur
    } else {
     $w selection to [expr $cur+1]
    }
   }
  }
  word {
   if {$cur < [$w index anchor]} {
    $w selection range [string wordstart [$w get] $cur] \
    [string wordend [$w get] [expr $anchor-1]]
   } else {
    $w selection range [string wordstart [$w get] $anchor] \
    [string wordend [$w get] $cur]
   }
  }
  line {
   $w selection range 0 end
  }
 }
 update idletasks
}
proc tkEntryAutoScan {w} {
 global tkPriv
 set x $tkPriv(x)
 if {$x >= [winfo width $w]} {
  $w xview scroll 2 units
  tkEntryMouseSelect $w $x
 } elseif {$x < 0} {
  $w xview scroll -2 units
  tkEntryMouseSelect $w $x
 }
 set tkPriv(afterId) [after 50 tkEntryAutoScan $w]
}
proc tkEntryKeySelect {w new} {
 if ![$w selection present] {
  $w selection from insert
  $w selection to $new
 } else {
  $w selection adjust $new
 }
 $w icursor $new
}
proc tkEntryInsert {w s} {
 if {$s == ""} {
  return
 }
 catch {
  set insert [$w index insert]
  if {([$w index sel.first] <= $insert)
   && ([$w index sel.last] >= $insert)} {
   $w delete sel.first sel.last
  }
 }
 $w insert insert $s
 tkEntrySeeInsert $w
}
proc tkEntryBackspace w {
 if [$w selection present] {
  $w delete sel.first sel.last
 } else {
  set x [expr {[$w index insert] - 1}]
  if {$x >= 0} {$w delete $x}
  if {[$w index @0] >= [$w index insert]} {
   set range [$w xview]
   set left [lindex $range 0]
   set right [lindex $range 1]
   $w xview moveto [expr $left - ($right - $left)/2.0]
  }
 }
}
proc tkEntrySeeInsert w {
 set c [$w index insert]
 set left [$w index @0]
 if {$left > $c} {
  $w xview $c
  return
 }
 set x [winfo width $w]
 while {([$w index @$x] <= $c) && ($left < $c)} {
  incr left
  $w xview $left
 }
}
proc tkEntrySetCursor {w pos} {
 $w icursor $pos
 $w selection clear
 tkEntrySeeInsert $w
}
proc tkEntryTranspose w {
 set i [$w index insert]
 if {$i < [$w index end]} {
  incr i
 }
 set first [expr $i-2]
 if {$first < 0} {
  return
 }
 set new [string index [$w get] [expr $i-1]][string index [$w get] $first]
 $w delete $first $i
 $w insert insert $new
 tkEntrySeeInsert $w
}
proc tk_focusNext w {
 set cur $w
 while 1 {
  set parent $cur
  set children [winfo children $cur]
  set i -1
  while 1 {
   incr i
   if {$i < [llength $children]} {
    set cur [lindex $children $i]
    if {[winfo toplevel $cur] == $cur} {
     continue
    } else {
     break
    }
   }
   set cur $parent
   if {[winfo toplevel $cur] == $cur} {
    break
   }
   set parent [winfo parent $parent]
   set children [winfo children $parent]
   set i [lsearch -exact $children $cur]
  }
  if {($cur == $w) || [tkFocusOK $cur]} {
   return $cur
  }
 }
}
proc tk_focusPrev w {
 set cur $w
 while 1 {
  if {[winfo toplevel $cur] == $cur}  {
   set parent $cur
   set children [winfo children $cur]
   set i [llength $children]
  } else {
   set parent [winfo parent $cur]
   set children [winfo children $parent]
   set i [lsearch -exact $children $cur]
  }
  while {$i > 0} {
   incr i -1
   set cur [lindex $children $i]
   if {[winfo toplevel $cur] == $cur} {
    continue
   }
   set parent $cur
   set children [winfo children $parent]
   set i [llength $children]
  }
  set cur $parent
  if {($cur == $w) || [tkFocusOK $cur]} {
   return $cur
  }
 }
}
proc tkFocusOK w {
 if {![winfo viewable $w]} {
  return 0
 }
 set code [catch {$w cget -takefocus} value]
 if {($code == 0) && ($value != "")} {
  if {$value == 0} {
   return 0
  } elseif {$value == 1} {
   return 1
  } else {
   set value [uplevel #0 $value $w]
   if {$value != ""} {
    return $value
   }
  }
 }
 set code [catch {$w cget -state} value]
 if {($code == 0) && ($value == "disabled")} {
  return 0
 }
 regexp Key|Focus "[bind $w] [bind [winfo class $w]]"
}
proc tk_focusFollowsMouse {} {
 set old [bind all <Enter>]
 set script {
  if {("%d" == "NotifyAncestor") || ("%d" == "NotifyNonlinear")
   || ("%d" == "NotifyInferior")} {
   focus %W
  }
 }
 if {$old != ""} {
  bind all <Enter> "$old; $script"
 } else {
  bind all <Enter> $script
 }
}
bind Listbox <1> {
 if [winfo exists %W] {
  tkListboxBeginSelect %W [%W index @%x,%y]
 }
}
bind Listbox <B1-Motion> {
 set tkPriv(x) %x
 set tkPriv(y) %y
 tkListboxMotion %W [%W index @%x,%y]
}
bind Listbox <ButtonRelease-1> {
 tkCancelRepeat
 %W activate @%x,%y
}
bind Listbox <Shift-1> {
 tkListboxBeginExtend %W [%W index @%x,%y]
}
bind Listbox <Control-1> {
 tkListboxBeginToggle %W [%W index @%x,%y]
}
bind Listbox <B1-Leave> {
 set tkPriv(x) %x
 set tkPriv(y) %y
 tkListboxAutoScan %W
}
bind Listbox <B1-Enter> {
 tkCancelRepeat
}
bind Listbox <Up> {
 tkListboxUpDown %W -1
}
bind Listbox <Shift-Up> {
 tkListboxExtendUpDown %W -1
}
bind Listbox <Down> {
 tkListboxUpDown %W 1
}
bind Listbox <Shift-Down> {
 tkListboxExtendUpDown %W 1
}
bind Listbox <Left> {
 %W xview scroll -1 units
}
bind Listbox <Control-Left> {
 %W xview scroll -1 pages
}
bind Listbox <Right> {
 %W xview scroll 1 units
}
bind Listbox <Control-Right> {
 %W xview scroll 1 pages
}
bind Listbox <Prior> {
 %W yview scroll -1 pages
 %W activate @0,0
}
bind Listbox <Next> {
 %W yview scroll 1 pages
 %W activate @0,0
}
bind Listbox <Control-Prior> {
 %W xview scroll -1 pages
}
bind Listbox <Control-Next> {
 %W xview scroll 1 pages
}
bind Listbox <Home> {
 %W xview moveto 0
}
bind Listbox <End> {
 %W xview moveto 1
}
bind Listbox <Control-Home> {
 %W activate 0
 %W see 0
 %W selection clear 0 end
 %W selection set 0
}
bind Listbox <Shift-Control-Home> {
 tkListboxDataExtend %W 0
}
bind Listbox <Control-End> {
 %W activate end
 %W see end
 %W selection clear 0 end
 %W selection set end
}
bind Listbox <Shift-Control-End> {
 tkListboxDataExtend %W end
}
bind Listbox <F16> {
 if {[selection own -displayof %W] == "%W"} {
  clipboard clear -displayof %W
  clipboard append -displayof %W [selection get -displayof %W]
 }
}
bind Listbox <space> {
 tkListboxBeginSelect %W [%W index active]
}
bind Listbox <Select> {
 tkListboxBeginSelect %W [%W index active]
}
bind Listbox <Control-Shift-space> {
 tkListboxBeginExtend %W [%W index active]
}
bind Listbox <Shift-Select> {
 tkListboxBeginExtend %W [%W index active]
}
bind Listbox <Escape> {
 tkListboxCancel %W
}
bind Listbox <Control-slash> {
 tkListboxSelectAll %W
}
bind Listbox <Control-backslash> {
 if {[%W cget -selectmode] != "browse"} {
  %W selection clear 0 end
 }
}
bind Listbox <2> {
 %W scan mark %x %y
}
bind Listbox <B2-Motion> {
 %W scan dragto %x %y
}
proc tkListboxBeginSelect {w el} {
 global tkPriv
 if {[$w cget -selectmode]  == "multiple"} {
  if [$w selection includes $el] {
   $w selection clear $el
  } else {
   $w selection set $el
  }
 } else {
  $w selection clear 0 end
  $w selection set $el
  $w selection anchor $el
  set tkPriv(listboxSelection) {}
  set tkPriv(listboxPrev) $el
 }
}
proc tkListboxMotion {w el} {
 global tkPriv
 if {$el == $tkPriv(listboxPrev)} {
  return
 }
 set anchor [$w index anchor]
 switch [$w cget -selectmode] {
  browse {
   $w selection clear 0 end
   $w selection set $el
   set tkPriv(listboxPrev) $el
  }
  extended {
   set i $tkPriv(listboxPrev)
   if [$w selection includes anchor] {
    $w selection clear $i $el
    $w selection set anchor $el
   } else {
    $w selection clear $i $el
    $w selection clear anchor $el
   }
   while {($i < $el) && ($i < $anchor)} {
    if {[lsearch $tkPriv(listboxSelection) $i] >= 0} {
     $w selection set $i
    }
    incr i
   }
   while {($i > $el) && ($i > $anchor)} {
    if {[lsearch $tkPriv(listboxSelection) $i] >= 0} {
     $w selection set $i
    }
    incr i -1
   }
   set tkPriv(listboxPrev) $el
  }
 }
}
proc tkListboxBeginExtend {w el} {
 if {([$w cget -selectmode] == "extended")
  && [$w selection includes anchor]} {
  tkListboxMotion $w $el
 }
}
proc tkListboxBeginToggle {w el} {
 global tkPriv
 if {[$w cget -selectmode] == "extended"} {
  set tkPriv(listboxSelection) [$w curselection]
  set tkPriv(listboxPrev) $el
  $w selection anchor $el
  if [$w selection includes $el] {
   $w selection clear $el
  } else {
   $w selection set $el
  }
 }
}
proc tkListboxAutoScan {w} {
 global tkPriv
 set x $tkPriv(x)
 set y $tkPriv(y)
 if {$y >= [winfo height $w]} {
  $w yview scroll 1 units
 } elseif {$y < 0} {
  $w yview scroll -1 units
 } elseif {$x >= [winfo width $w]} {
  $w xview scroll 2 units
 } elseif {$x < 0} {
  $w xview scroll -2 units
 } else {
  return
 }
 tkListboxMotion $w [$w index @$x,$y]
 set tkPriv(afterId) [after 50 tkListboxAutoScan $w]
}
proc tkListboxUpDown {w amount} {
 global tkPriv
 $w activate [expr [$w index active] + $amount]
 $w see active
 switch [$w cget -selectmode] {
  browse {
   $w selection clear 0 end
   $w selection set active
  }
  extended {
   $w selection clear 0 end
   $w selection set active
   $w selection anchor active
   set tkPriv(listboxPrev) [$w index active]
   set tkPriv(listboxSelection) {}
  }
 }
}
proc tkListboxExtendUpDown {w amount} {
 if {[$w cget -selectmode] != "extended"} {
  return
 }
 $w activate [expr [$w index active] + $amount]
 $w see active
 tkListboxMotion $w [$w index active]
}
proc tkListboxDataExtend {w el} {
 set mode [$w cget -selectmode]
 if {$mode == "extended"} {
  $w activate $el
  $w see $el
  if [$w selection includes anchor] {
   tkListboxMotion $w $el
  }
 } elseif {$mode == "multiple"} {
  $w activate $el
  $w see $el
 }
}
proc tkListboxCancel w {
 global tkPriv
 if {[$w cget -selectmode] != "extended"} {
  return
 }
 set first [$w index anchor]
 set last $tkPriv(listboxPrev)
 if {$first > $last} {
  set tmp $first
  set first $last
  set last $tmp
 }
 $w selection clear $first $last
 while {$first <= $last} {
  if {[lsearch $tkPriv(listboxSelection) $first] >= 0} {
   $w selection set $first
  }
  incr first
 }
}
proc tkListboxSelectAll w {
 set mode [$w cget -selectmode]
 if {($mode == "single") || ($mode == "browse")} {
  $w selection clear 0 end
  $w selection set active
 } else {
  $w selection set 0 end
 }
}
bind Scrollbar <Enter> {
 if $tk_strictMotif {
  set tkPriv(activeBg) [%W cget -activebackground]
  %W config -activebackground [%W cget -background]
 }
 %W activate [%W identify %x %y]
}
bind Scrollbar <Motion> {
 %W activate [%W identify %x %y]
}
bind Scrollbar <Leave> {
 if $tk_strictMotif {
  %W config -activebackground $tkPriv(activeBg)
 }
 %W activate {}
}
bind Scrollbar <1> {
 tkScrollButtonDown %W %x %y
}
bind Scrollbar <B1-Motion> {
 tkScrollDrag %W %x %y
}
bind Scrollbar <B1-B2-Motion> {
 tkScrollDrag %W %x %y
}
bind Scrollbar <ButtonRelease-1> {
 tkScrollButtonUp %W %x %y
}
bind Scrollbar <B1-Leave> {
}
bind Scrollbar <B1-Enter> {
}
bind Scrollbar <2> {
 tkScrollButton2Down %W %x %y
}
bind Scrollbar <B1-2> {
}
bind Scrollbar <B2-1> {
}
bind Scrollbar <B2-Motion> {
 tkScrollDrag %W %x %y
}
bind Scrollbar <ButtonRelease-2> {
 tkScrollButtonUp %W %x %y
}
bind Scrollbar <B1-ButtonRelease-2> {
}
bind Scrollbar <B2-ButtonRelease-1> {
}
bind Scrollbar <B2-Leave> {
}
bind Scrollbar <B2-Enter> {
}
bind Scrollbar <Control-1> {
 tkScrollTopBottom %W %x %y
}
bind Scrollbar <Control-2> {
 tkScrollTopBottom %W %x %y
}
bind Scrollbar <Up> {
 tkScrollByUnits %W v -1
}
bind Scrollbar <Down> {
 tkScrollByUnits %W v 1
}
bind Scrollbar <Control-Up> {
 tkScrollByPages %W v -1
}
bind Scrollbar <Control-Down> {
 tkScrollByPages %W v 1
}
bind Scrollbar <Left> {
 tkScrollByUnits %W h -1
}
bind Scrollbar <Right> {
 tkScrollByUnits %W h 1
}
bind Scrollbar <Control-Left> {
 tkScrollByPages %W h -1
}
bind Scrollbar <Control-Right> {
 tkScrollByPages %W h 1
}
bind Scrollbar <Prior> {
 tkScrollByPages %W hv -1
}
bind Scrollbar <Next> {
 tkScrollByPages %W hv 1
}
bind Scrollbar <Home> {
 tkScrollToPos %W 0
}
bind Scrollbar <End> {
 tkScrollToPos %W 1
}
proc tkScrollButtonDown {w x y} {
 global tkPriv
 set tkPriv(relief) [$w cget -activerelief]
 $w configure -activerelief sunken
 set element [$w identify $x $y]
 if {$element == "slider"} {
  tkScrollStartDrag $w $x $y
 } else {
  tkScrollSelect $w $element initial
 }
}
proc tkScrollButtonUp {w x y} {
 global tkPriv
 tkCancelRepeat
 $w configure -activerelief $tkPriv(relief)
 tkScrollEndDrag $w $x $y
 $w activate [$w identify $x $y]
}
proc tkScrollSelect {w element repeat} {
 global tkPriv
 if {$element == "arrow1"} {
  tkScrollByUnits $w hv -1
 } elseif {$element == "trough1"} {
  tkScrollByPages $w hv -1
 } elseif {$element == "trough2"} {
  tkScrollByPages $w hv 1
 } elseif {$element == "arrow2"} {
  tkScrollByUnits $w hv 1
 } else {
  return
 }
 if {$repeat == "again"} {
  set tkPriv(afterId) [after [$w cget -repeatinterval] \
  tkScrollSelect $w $element again]
 } elseif {$repeat == "initial"} {
  set delay [$w cget -repeatdelay]
  if {$delay > 0} {
   set tkPriv(afterId) [after $delay tkScrollSelect $w $element again]
  }
 }
}
proc tkScrollStartDrag {w x y} {
 global tkPriv
 if {[$w cget -command] == ""} {
  return
 }
 set tkPriv(pressX) $x
 set tkPriv(pressY) $y
 set tkPriv(initValues) [$w get]
 set iv0 [lindex $tkPriv(initValues) 0]
 if {[llength $tkPriv(initValues)] == 2} {
  set tkPriv(initPos) $iv0
 } else {
  if {$iv0 == 0} {
   set tkPriv(initPos) 0.0
  } else {
   set tkPriv(initPos) [expr (double([lindex $tkPriv(initValues) 2])) \
   / [lindex $tkPriv(initValues) 0]]
  }
 }
}
proc tkScrollDrag {w x y} {
 global tkPriv
 if {$tkPriv(initPos) == ""} {
  return
 }
 set delta [$w delta [expr $x - $tkPriv(pressX)] [expr $y - $tkPriv(pressY)]]
 if [$w cget -jump] {
  if {[llength $tkPriv(initValues)] == 2} {
   $w set [expr [lindex $tkPriv(initValues) 0] + $delta] \
   [expr [lindex $tkPriv(initValues) 1] + $delta]
  } else {
   set delta [expr round($delta * [lindex $tkPriv(initValues) 0])]
   eval $w set [lreplace $tkPriv(initValues) 2 3 \
   [expr [lindex $tkPriv(initValues) 2] + $delta] \
   [expr [lindex $tkPriv(initValues) 3] + $delta]]
  }
 } else {
  tkScrollToPos $w [expr $tkPriv(initPos) + $delta]
 }
}
proc tkScrollEndDrag {w x y} {
 global tkPriv
 if {$tkPriv(initPos) == ""} {
  return
 }
 if [$w cget -jump] {
  set delta [$w delta [expr $x - $tkPriv(pressX)] \
  [expr $y - $tkPriv(pressY)]]
  tkScrollToPos $w [expr $tkPriv(initPos) + $delta]
 }
 set tkPriv(initPos) ""
}
proc tkScrollByUnits {w orient amount} {
 set cmd [$w cget -command]
 if {($cmd == "") || ([string first \
  [string index [$w cget -orient] 0] $orient] < 0)} {
  return
 }
 set info [$w get]
 if {[llength $info] == 2} {
  uplevel #0 $cmd scroll $amount units
 } else {
  uplevel #0 $cmd [expr [lindex $info 2] + $amount]
 }
}
proc tkScrollByPages {w orient amount} {
 set cmd [$w cget -command]
 if {($cmd == "") || ([string first \
  [string index [$w cget -orient] 0] $orient] < 0)} {
  return
 }
 set info [$w get]
 if {[llength $info] == 2} {
  uplevel #0 $cmd scroll $amount pages
 } else {
  uplevel #0 $cmd [expr [lindex $info 2] + $amount*([lindex $info 1] - 1)]
 }
}
proc tkScrollToPos {w pos} {
 set cmd [$w cget -command]
 if {($cmd == "")} {
  return
 }
 set info [$w get]
 if {[llength $info] == 2} {
  uplevel #0 $cmd moveto $pos
 } else {
  uplevel #0 $cmd [expr round([lindex $info 0]*$pos)]
 }
}
proc tkScrollTopBottom {w x y} {
 set element [$w identify $x $y]
 if [string match *1 $element] {
  tkScrollToPos $w 0
 } elseif [string match *2 $element] {
  tkScrollToPos $w 1
 }
}
proc tkScrollButton2Down {w x y} {
 global tkPriv
 set element [$w identify $x $y]
 if {($element == "arrow1") || ($element == "arrow2")} {
  tkScrollButtonDown $w $x $y
  return
 }
 tkScrollToPos $w [$w fraction $x $y]
 update idletasks
 set tkPriv(relief) [$w cget -activerelief]
 $w configure -activerelief sunken
 $w activate slider
 tkScrollStartDrag $w $x $y
}
proc tkerror err {
 global errorInfo
 set info $errorInfo
 set button [tk_dialog .tkerrorDialog "Error in Tcl Script" \
 "Error: $err" error 0 OK "Skip Messages" "Stack Trace"]
 if {$button == 0} {
  return
 } elseif {$button == 1} {
  return -code break
 }
 set w .tkerrorTrace
 catch {destroy $w}
 toplevel $w -class ErrorTrace
 wm minsize $w 1 1
 wm title $w "Stack Trace for Error"
 wm iconname $w "Stack Trace"
 button $w.ok -text OK -command "destroy $w"
 text $w.text -relief sunken -bd 2 -yscrollcommand "$w.scroll set" \
 -setgrid true -width 60 -height 20
 scrollbar $w.scroll -relief sunken -command "$w.text yview"
 pack $w.ok -side bottom -padx 3m -pady 2m
 pack $w.scroll -side right -fill y
 pack $w.text -side left -expand yes -fill both
 $w.text insert 0.0 $info
 $w.text mark set insert 0.0
 wm withdraw $w
 update idletasks
 set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
 - [winfo vrootx [winfo parent $w]]]
 set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
 - [winfo vrooty [winfo parent $w]]]
 wm geom $w +$x+$y
 wm deiconify $w
 if {[grab current .] != ""} {
  grab release [grab current .]
 }
}
